% Get property from the specified object and return the value.
%
% function val = get(self,varargin)
%
% See discussion of the get/set methods in <a href="matlab:helpwin
% 'FAESOR/classes/Contents'">classes/Contents</a>. 
%
function val = get(self,varargin)
if (nargin == 1)
    val = {{{'gcell_map'}, {'map from finite element node (indexed by node ID) to the geometric cells, cell array [d,1] of arrays'}};
        };
    return;
else
    prop_name=varargin{1};
    switch prop_name
        case 'gcell_map'
            val = self.gcell_map;
        otherwise
            error(['Unknown property name ''' prop_name '''!']);
    end
end

