% Concatenate the connectivities of two gcell sets
%
% function self = cat(self, other)
% where
%  self, other = members of the same class, descendent of the gcellset
function self = cat(self, other)
    self.conn =[self.conn;other.conn];
    if (~isempty(self.label)) || (~isempty(other.label))
        if (isempty(self.label))
            self.label=zeros(size(self.conn,1),1);
        end
        if (isempty(other.label))
            other.label=zeros(size(other.conn,1),1);
        end
    end
    self.label=[self.label;other.label];
end