% Update the connectivity after the IDs of nodes changed.
%
% function self = update_connectivity(self,NewIDs)
%
% Inputs:
% NewIDs= new node IDs. Note that the conn array points into the  NewIDs
% array. After the connectivity was updated this is no longer true!
%
function self = update_connectivity(self,NewIDs)
    for i=1:size(self.conn,1)
        self.conn(i,:)=NewIDs(self.conn(i,:));
    end
end
