

function Cylindrical_shell
    mu=6000;
    kappa=24000;%MPa[x,y]=solve ('24000-x/3/( 1-2*y)','6000-x/2/(1+y)')
    E =1.6615e+004;
    nu=0.3846;
    stabfact=  0.2*mu/2;
    stabfact=  0.08*mu/2;
    stabfact=  0.001*mu/2;
    stabfact=  10*0.2*mu/2;
    stabfact=  0.05*mu/2;
    %     E/3/( 1-2*nu)
    rho=5e-9;
    nus = [(1:100)*0+nu];
    %
    iR= 8;
    Thickness =2;
    Length =15;
    rA=pi;
    tol= 0.001;
    Fmag=-7500/15;
    maxit = 30;

    nincr = 5;
    graphics =false;
    cam = [-46.4329   49.8152  161.1106    3.6186  9.4315    7.0679    0.0748    0.9703 -0.2301    6.5474];
    scale=1;
    nas = (8:-1:1);
    nas = (2:16);
    nts = (1:4);
    circumlt=2;
    na = 3;
    nc = circumlt*[na];
    nt = 2;

    Report =@(x) (disp(x) );
    Report =@(x) ([]);
    %
    function [fens,gcells] = h8cylH8()
        [fens,gcells]=block(rA, Thickness, Length, nc,nt,na);
    end
    function [fens,gcells] = t4cyl()
        [fens,gcells]=t4block(rA, Thickness, Length, nc,nt,na);
    end
    function [fens,gcells] = t4cyld()
        [fens,gcells]=t4blocka(rA, Thickness, Length, nc,nt,na);
        for j=1:length(gcells),gcells(j) =set(gcells(j),'label','overlay');end
        [fens1,gcells1]=t4blockb(rA, Thickness, Length, nc,nt,na);
        [fens,gcells1,gcells2] = merge_meshes(fens1, gcells1, fens, gcells, 1/1000);
        gcells=cat(2,gcells1,gcells2);
    end
    function [fens,gcells] = h8cylH27()
        [fens,gcells] = h8cylH8();
        [fens,gcells] = H8_to_H27(fens,gcells);
    end
    function [fens,gcells] = h8cylH64()
        [fens,gcells] = h8cylH8();
        [fens,gcells] = H8_to_H64(fens,gcells);
    end


    eix=1;
    clear eltyd

   
    %
%     eltyd(eix).label ='H8';
%     eltyd(eix).mf =@h8cylH8;
%     eltyd(eix).blf =@feblock_defor_nonlinear;
%     eltyd(eix).integration_rule= gauss_rule (3,2);
%     eltyd(eix).line_integration_rule=gauss_rule (1,2);
%     eltyd(eix).stabfact =stabfact;
%     eltyd(eix).styl='rx-.';
%     eix=eix+1;
%     
    eltyd(eix).label ='NICE-T4';
    eltyd(eix).mf =@t4cyl;
    eltyd(eix).blf =@feblock_defor_nonlinear_nice;
    eltyd(eix).integration_rule= simplex_nq_rule (3);
    eltyd(eix).line_integration_rule=tri_rule(1);
    eltyd(eix).stabfact =stabfact;
    eltyd(eix).styl='m^-';
    eix=eix+1;

    eltyd(eix).label ='NICE-H8';
    eltyd(eix).mf =@h8cylH8;
    eltyd(eix).blf =@feblock_defor_nonlinear_nice;
    eltyd(eix).integration_rule= tensprod_nq_rule (struct('dim',3,'order',1));
    eltyd(eix).line_integration_rule=tensprod_nq_rule (struct('dim',1,'order',1));
    eltyd(eix).stabfact =stabfact;
    eltyd(eix).styl='md-';
    eix=eix+1;

%     eltyd(eix).label ='NICE-T4d';
%     eltyd(eix).mf =@t4cyld;
%     eltyd(eix).blf =@feblock_defor_nonlinear_nice;
%     eltyd(eix).integration_rule= simplex_nq_rule (3);
%     eltyd(eix).line_integration_rule=gauss_rule(1, 3);
%     eltyd(eix).stabfact =stabfact/4;
%     eltyd(eix).styl='mv-';
%     eix=eix+1;
    
    
%     eltyd(eix).label ='H27';
%     eltyd(eix).mf =@h8cylH27;
%     eltyd(eix).blf =@feblock_defor_nonlinear;
%     eltyd(eix).integration_rule=gauss_rule (3,3);
%     eltyd(eix).line_integration_rule=gauss_rule(1, 3);
%     eltyd(eix).styl='ks-';
%     eix=eix+1;

%     eltyd(eix).label ='NICE-H27';
%     eltyd(eix).mf =@h8cylH27;
%     eltyd(eix).blf =@feblock_defor_nonlinear_nice;
%     eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',2));
%     eltyd(eix).line_integration_rule=tensprod_nq_rule (struct('dim',1,'order',2));
%     eltyd(eix).styl='mh-';
%     eix=eix+1;

%     eltyd(eix).label ='NICE-H64';
%     eltyd(eix).mf =@h8cylH64;
%     eltyd(eix).blf =@feblock_defor_nonlinear_nice;
%     eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',3));
%     eltyd(eix).line_integration_rule=tensprod_nq_rule (struct('dim',1,'order',3));
%     eltyd(eix).styl='mh-';
%     eix=eix+1;


    function [utip] =Compute
        %                   Mesh
        [fens,gcells] = eltyd(eix).mf ();
        feb = eltyd(eix).blf (struct ('mater',[], 'gcells',gcells));
        [fens, gcells]=renum_mesh_renumber(fens, gcells,...
            renum_mesh_numbering(fens,genconn(feb), 'symamd'));
        bgcells =mesh_bdry(gcells(gcell_select(fens, gcells, struct('label', 0))), []);
        icl = gcell_select(fens, bgcells, struct('box', [rA,rA,-Inf,Inf,-Inf,Inf],'inflate',tol));
        bgcells =mesh_bdry(bgcells(icl), []);
        icl = gcell_select(fens, bgcells, struct('box', [rA,rA,0,0,-Inf,Inf],'inflate',2*tol));

        cncl = fenode_select(fens, struct('box', [rA,rA,0,0,Length,Length ],'inflate',tol));
        for i=1:length (fens)
            xyz=get (fens(i),'xyz');
            x=xyz(1); y=xyz(2); z=xyz(3);
            xyz= [0, y-iR-Thickness, z];
            xyz = xyz*rotmat([0, 0, -x])+ [0,iR+Thickness,0];
            fens(i)=set(fens(i),'xyz', xyz);
        end
        %         gv=drawmesh( {fens,gcells});
        %         gv=drawmesh( {fens,bgcells(icl)},'gv',gv,'facecolor','blue');
        %         view(3); return
        % MaterialAnd
        prop = property_linel_iso (struct('E',E,'nu',nu));
        mater = mater_defor_neohook(struct('property',prop));
        % Finite element block
        feb = eltyd(eix).blf (struct ('mater',mater, 'gcells',gcells,...
            'integration_rule',eltyd(eix).integration_rule));
        efeb = eltyd(eix).blf (struct ('mater',mater, 'gcells',bgcells(icl),...
            'integration_rule',eltyd(eix).line_integration_rule));
        sfeb = eltyd(eix).blf (struct ('mater',mater, 'gcells',bgcells,...
            'integration_rule',eltyd(eix).line_integration_rule));
        % Geometry
        geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
        % Define the displacement field
        u   = 0*geom; % zero out
        % Apply EBC's
        ebc_fenids=fenode_select (fens,struct('box',[0,0,0,0,0,Length],'inflate',tol));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=ebc_fenids*0+1;
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        ebc_fenids=fenode_select (fens,struct('box',[0,0,0,0,0,Length],'inflate',tol));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=ebc_fenids*0+2;
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        %         ebc_fenids=fenode_select (fens,struct('box',[0,0,0,0,0,Length],'inflate',tol));
        %         ebc_prescribed=ones(1,length (ebc_fenids));
        %         ebc_comp=[];
        %         ebc_val=ebc_fenids*0;
        %         u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        ebc_fenids=fenode_select (fens,struct('box',[-Inf,Inf,-Inf,Inf,0,0],'inflate',tol));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=ebc_fenids*0+3;
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        ebc_fenids=fenode_select (fens,struct('box',[0,0,-Inf,Inf,0,Length],'inflate',tol));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=ebc_fenids*0+1;
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        u   = apply_ebc (u);

        % Number equations
        u   = numbereqns (u);
        % Now comes the nonlinear solution
        tup = 1;
        u = u*0; % zero out the displacement
        utol = 1e-15*get(u, 'neqns');
        us={};

        if graphics, gv=graphic_viewer; end

        K = start (sparse_altassem_sysmat, get(u, 'neqns'));
        %         K = start (sparse_sysmat, get(u, 'neqns'));

        t=0; % time=load magnitude
        incr=1;
        while (incr <= nincr)
            t = t + tup / nincr;
            Report(['Increment ' num2str(incr) ]); % pause
            % Initialization
            u1 = u; % guess
            u1 = apply_ebc(u1);
            du = 0*u; % this will hold displacement increment
            du = apply_ebc(du);
            iter=1;
            if graphics,
                gv=reset(clear(gv,[]),[]);
                camset(gv,cam);
                draw(feb,gv, struct ('x', geom,'u',u, 'facecolor','none'));
%                 draw(feb,gv, struct ('x', geom,'u',0*u, 'facecolor','Yellow','alpha', 0.2));
%                 headlight(gv);
                cam =camget(gv);
            end
            while 1
                prop = property_linel_iso (struct('E',E,'nu',nus(iter)));
                mater = mater_defor_neohook(struct('property',prop));
                feb1=set(feb,'mater',mater);
                fi=force_intensity(struct('magn',[0;Fmag*t;0]));
                F = start (sysvec, get(u, 'neqns'));
                F = assemble (F, distrib_loads(efeb, geom, u, fi, 1));
%                  sum(get(F,'vec'))
                [feb1,evs] = restoring_force(feb1,geom,u1,u);       % Internal forces
                F = assemble (F, evs);
                [febstab,evs] = restoring_force_stab(feb1,geom,u1,u,eltyd(eix).stabfact);       % Internal forces
                F = assemble (F, evs);
%                 Fstab = start (sysvec, get(u, 'neqns'));
%                 Fstab = assemble (Fstab, evs);
%                 sum((abs(get(Fstab,'vec'))))
                ems=stiffness(feb1, geom, u1,u);% Current material stiffness
                K = assemble (K, ems);
                ems =stiffness_geo(feb1, geom, u1,u); % Current geometric stiffness
                K = assemble (K, ems);
                ems =stiffness_stab(feb1, geom, u1,u,eltyd(eix).stabfact); % Current geometric stiffness
                K = assemble (K, ems);
                K = external_decomposition (K,  []);
                du = scatter_sysvec(du, K\F); % Displacement increment
                %                 max(abs(get(F,'vec')))
                u1 = u1 + du;                                       % increment displacement
                K = reinitialize (K);
                %                 draw(sfeb,gv, struct ('x', geom,'u',u1, 'facecolor','none'));
                if graphics, camset (gv,cam); pause(0.5); cam =camget(gv); end
                Report(['   It. ' num2str(iter) ': ||du||=' num2str(norm(du))]);
                if (max(abs(gather(du,[],'values'))) < utol) break; end;% convergence check
                if (iter >maxit)% bailout for failed convergence
                    u=u*0; break;
                end
                iter=iter+1;
            end
            [feb,ignore] = restoring_force(feb,geom,u1,u);        % final update
            Report(['    Converged for t=' num2str(t)]); % pause
            u = u1;                                               % update the displacement
            us{end+1} =u;
            utip=gather(u,cncl,'values','noreshape');
            utip=utip(2);
            incr = incr + 1;
        end
        if graphics,
            gv=reset(clear(gv,[]),[]);camset (gv,cam); 
            draw(feb,gv, struct ('x', geom,'u',u, 'facecolor','red'));
            draw(feb,gv, struct ('x', geom,'u',0*u, 'facecolor','Yellow'));
        end
        %         camset(gv, [  -75.6602  613.9688  210.2074   20.6651   38.3517 20.5774         0         0    1.0000    5.3084]);
        clear K
        save ([mfilename '-nc' num2str(nc) '-nt' num2str(nt) '-' eltyd(eix).label])
    end

    for nt =nts
        for eix = 1:length(eltyd)
            utips = [];
            for na =nas
                nc=circumlt*na;
                utips(end+1)=Compute;
            end
            ncs=circumlt*nas;
            disp(['% ' eltyd(eix).label ' nc=' num2str(ncs) ' nt=' num2str(nt) ' stabfact=' num2str(stabfact)]);
            disp(['Data{end+1}=[' ]);
            disp([ncs;utips]);
            disp([']; Style{end+1}=''' eltyd(eix).styl '''; Legends{end+1} =''' eltyd(eix).label  ''';']);
            eltyd1 =eltyd(eix);
            save ([mfilename  '-nt' num2str(nt) '-' eltyd1.label '-results'], 'eltyd1', 'nas', 'utips')
        end
    end
end