function slot
    smult=0;
    stabfact=0.001;
    E=24;
    graphics=true;
    doeig=~true;
    magn=1;

    nu =0.499995;


            [h,se]=doitt(@feblock_defor_ss_nice,tensprod_nq_rule(struct('dim',2,'order',1)))
                    [pG,ignore]=gaussquad(2);
                    pG=abs(pG(1));
                    [h,se]=doitt(@feblock_defor_ss_pase,v2_gauss_rule(2,                    [2],1, pG)) 
    %    [h,se]=doitt(@feblock_defor_ss,gauss_rule(2,2))
%    [h,se]=doitt(@feblock_defor_ss_sri,gauss_rule(2,[1,2]))

   
    function [hs,se]=doitt(blf,ir)
        disp(['Uniform  traction on a block with a slot: ' func2str(blf)]);
        % Parameters:

        fx=figure;
        fy = figure;

        % Mesh
        hs=[];        se=[];
        % for n=[8,16,20]
                for n=[8,16,32,64]
%         for n=[20]
            h=1/n;
            %             v= [];
            %             nr= max(1, ceil(0.05*pi/2/(h))*2);
            %             for j=nr:-1:0
            %                 v=[v; [0.15,0]+0.05*[cos(j/nr*pi/2),sin(j/nr*pi/2)]];
            %             end
            %             v=[v; 1,0; 1,1; 0,1; 0,0.05]; 
            %             [fens,gcells] = targe2_mesher_vl(v,1.0,struct('mesh_size',2*h));
            %             [fens,gcells] = T3_to_Q4(fens,gcells,[]);
            options.subdivisions=1;
            options.thickness=1;
            [fens,gcells]=slotG(options);
             connected = find_unconn_fens(fens, gcells);
            [fens, new_numbering] =compact_fens(fens, connected);
            gcells = renumber_gcell_conn(gcells, new_numbering);
            validate_mesh(fens, gcells);

            [fens,gcells] = Q4_refine(fens,gcells);
            %                 mesh{1}=fens;
            %                 mesh{2}=gcells;
            %                 drawmesh(mesh); view (2); pause 
            % Material
            prop = property_linel_iso (struct('E',E,'nu',nu));
            mater = mater_defor_ss_linel_biax (struct('property',prop, ...
                'reduction','strain'));
            % Finite element block
            feb = blf(struct ('mater',mater, 'gcells',gcells, 'integration_rule',ir,'stabfact',stabfact));
            % Geometry
            xyz=get(fens,'xyz');
            geom = field(struct ('name',['geom'], 'dim', 2, 'data',xyz(:,1:2)));
            % Define the displacement field
            u   = clone(geom,'u');
            u   = u*0; % zero outfunction five
            % Apply EBC's
            % Now the rollers at the bottom
            ebc_fenids=fenode_select (fens,struct('box',[0,1,0, 0],'inflate',h/100));
            ebc_prescribed=ones(1,length (ebc_fenids));
            ebc_comp=2*ones(1,length (ebc_fenids));
            ebc_val=ebc_fenids*0;
            u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
            % Now the rollers at the sidesa press function five
            ebc_fenids=fenode_select (fens,struct('box',[0, 0,0,1],'inflate',h/100));
            ebc_prescribed=ones(1,length (ebc_fenids));
            ebc_comp=1*ones(1,length (ebc_fenids));
            ebc_val=ebc_fenids*0;
            u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
            ebc_fenids=fenode_select (fens,struct('box',[1,1,0,1],'inflate',h/100));
            ebc_prescribed=ones(1,length (ebc_fenids));
            ebc_comp=1*ones(1,length (ebc_fenids));
            ebc_val=ebc_fenids*0;
            u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
            u   = apply_ebc (u);
            % Number equations
            u   = numbereqns (u);
            % Assemble the system matrix
            K = start (sparse_sysmat, get(u, 'neqns'));
            K = assemble (K, stiffness(feb, geom, u));
             % Load
            fi= force_intensity(struct ('magn',[0; magn]));
            bdry_gcells = mesh_bdry(gcells, struct('other_dimension',1));
            bcl = gcell_select(fens, bdry_gcells, ...
                struct ('box',[0 1 1 1],'inflate',h/100));
            lfeb = feblock_defor_ss(struct ('mater',mater, 'gcells',subset(bdry_gcells,bcl),...
                'integration_rule',gauss_rule(1, 1)));
            F = start (sysvec, get(u, 'neqns'));
            F = assemble (F, distrib_loads(lfeb, geom, u, fi, 2));
            % Solve
            a = get(K,'mat');
            b = get(F,'vec');
            x = a\b;
            u = scatter_sysvec(u, x);
            disp (['n=' num2str(n) ' Strain energy =' num2str(x'*b/2)])
            hs=[hs h];
            se =[se x'*b/2];

            fld = field_from_integration_points(feb, geom, u, [], 'vol_strain', 1);
            c =fenode_select (fens,struct('box',[0,1,0, 0],'inflate',h/100));
            pressurex=E/3/(1-2*nu)*gather (fld,c,'values');
            positionx=gather (geom,c,'values','noreshape');
            [ignore,ix]=sort(positionx(:,1));
            figure(fx); plot (positionx(ix,1),pressurex(ix),'bo-'); hold on, pause (1)
            c =fenode_select (fens,struct('box',[0,0,0, 1],'inflate',h/100));
            pressurey=E/3/(1-2*nu)*gather (fld,c,'values');
            positiony=gather (geom,c,'values','noreshape');
            [ignore,ix]=sort(positiony(:,2));
            figure(fy); plot (positiony(ix,2),pressurey(ix),'rs-'); hold on, pause (1)

            % Plot
            if graphics
                gv=graphic_viewer;
                gv=reset (gv,struct ([]));
                scale=1;
                cmap = jet;
                nvals=get(fld,'values');%min(nvals),max(nvals)
                % nvalsrange=[-0.0001 0.0001];%[min(nvals),max(nvals)]
                nvalsrange=[min(nvals),max(nvals)];
                dcm=data_colormap(struct ('range',nvalsrange, 'colormap',cmap));
                colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, nvals)));
                draw(feb,gv, struct ('x', geom, 'u', +scale*u,'colorfield',colorfield, 'shrink',1.0));
                %         draw(feb,gv, struct ('x', geom, 'u', +scale*u,'facecolor','none', 'shrink',1.0));
                % geom3d=combine (geom, 0*fld);
                % u3d=combine (u, 100000000*fld);
                % draw(feb,gv, struct ('x', geom3d, 'u', +scale*u3d,'colorfield',colorfield, 'shrink',1.0));
                colormap(cmap);
                cbh=colorbar;
                set(cbh,...
                    'Position',[0.8 0.15 0.05 0.7],...
                    'YLim',[0,1],...
                    'YTick',[0,1],...
                    'YTickLabel',{[num2str(nvalsrange(1))],[num2str(nvalsrange(2))]});%{[num2str((min(nvals)))],[num2str((max(nvals)))]}
                set(get(cbh,'XLabel'),'String','Volumetric strain');
                view (2)
                pause(2); % next eigenvector
                %         for i=1:length(fens)
                %             draw(fens(i),gv, struct ('x', geom, 'u', 0*u, 'facecolor','blue'));
                %         end
                
            end
        end
    end
end
