% Set property in the specified object.
%
% function retval = set(self,varargin)
%
% See discussion of the get/set methods in <a href="matlab:helpwin
% 'WFEM/classes/Contents'">classes/Contents</a>. 
%
function retval = set(self,varargin)
    if (nargin == 1)
        retval = {{{'Rayleigh_damping_stiffness'}, {'Rayleigh_damping_stiffness'}};
            {{'Rayleigh_damping_mass'}, {'Rayleigh_damping_mass'}};
            } ;
        return;
    end
    prop_name=varargin{1};
    val=varargin{2};
    switch prop_name
        case 'Rayleigh_damping_stiffness'
            self.Rayleigh_damping_stiffness = val;
        otherwise
            error(['Unknown property ''' prop_name '''!']);
    end
    retval=self; % return self
end
