try,avw_blank;catch,error('AVWTk is required; run AVWTk_init');end


[t,v,tmid] = voximg_to_T4(avw.img,[32000]);
[dx, dy, dz]=avw_pixdim(avw);

v(:,1)=dx*v(:,1);v(:,2)=dy*v(:,2);v(:,3)=dz*v(:,3);
Initial_number = size(t,1);
clear coarsening_options;
coarsening_options.stretch=1.25;
coarsening_options.desired_ts =mean([dx,dy,dz]);
f = t4util_bdry(t(find(tmid==32000),:));
bv =zeros(size(v,1),1);
bv(f)=1;
coarsening_options.bv=bv;
clear smoothing_options;

disp( ['Mesh size: initial ' num2str(Initial_number)])

tic;
[t,v,tmid] = t4util_coarsen(t,v,tmid,coarsening_options);
Elapsed =toc;
disp( ['Elapsed time ' num2str(Elapsed)])

f = t4util_bdry(t(find(tmid==32000),:));
smoothing_options.f=f;
smoothing_options.method='laplace';
smoothing_options.npass=5;
[t,v] =smoothing(t,v,smoothing_options);

disp( ['Mesh size: final ' num2str(size(t,1))])

fens =fenodeset(struct('id',(1:size(v,1))','xyz',v));
gcells =gcellset_T4(struct('conn',double(t)));
bg=mesh_bdry(gcells);
gv=drawmesh({fens,bg},'gcells','facecolor','y','edgecolor','none');
rotate(gv);