
        Meshf=@block2d; ne=[1,2,4,8,16,32];
    Convertf=@Q4_to_Q9;
        integration_rule = gauss_rule(2, 2);
        Edge_integration_rule = gauss_rule(1,2);
febf =@feblock_defor_ss;
        Style ='rx--'; Label='Q9-2x2';

% 
%         Meshf=@block2d; ne=[1,2,4,8,16,32];
%     Convertf=@Q4_to_Q9;
%         integration_rule = gauss_rule(2, 3);
%         Edge_integration_rule = gauss_rule(1,3);
% febf =@feblock_defor_ss;
%         Style ='rs-'; Label='Q9-3x3';


Meshf=@block2d; ne=[1,2,4,8,16,32];
Convertf=@Q4_to_Q9;
integration_rule =tensprod_nq_rule(struct('dim',2,'order',2));
Edge_integration_rule =tensprod_nq_rule(struct('dim',1,'order',2));
% Edge_integration_rule =gauss_rule(1,3);
febf =@feblock_defor_ss_asnice;
Style ='bx-'; Label='asNICE-Q9';
% 
% Meshf=@block2d; ne=[1,2,4,8,16,32];
% Convertf=@Q4_to_Q9;
% integration_rule =tensprod_nq_rule(struct('dim',2,'order',2));
% Edge_integration_rule =tensprod_nq_rule(struct('dim',1,'order',2));
% febf =@feblock_defor_ss_nicer;
% Style ='ms-'; Label='NICER-Q9';
%     %
%     Meshf=@block2d; ne=[2,4,8,16,32,64];
%     Convertf=[];
%     integration_rule =tensprod_nq_rule(struct('dim',2,'order',1));
%     Edge_integration_rule =tensprod_nq_rule(struct('dim',1,'order',1));
%     febf =@feblock_defor_ss_nicer;
%     Style ='md-'; Label='NICER-Q4';
    
%     Meshf=@t3block2d; ne=[2,4,8,16,32,64];
%     Convertf=[];
%     integration_rule =simplex_nq_rule(struct('dim',2,'order',1));
%     Edge_integration_rule =gauss_rule(1, 1);
%     febf =@feblock_defor_ss_nicer;
%     Style ='m^-'; Label='NICER-T3';

    Meshf=@block2d; ne=[1,2,4,8,16,32,64];
    Convertf=[];
    integration_rule =tensprod_nq_rule(struct('dim',2,'order',1));
    Edge_integration_rule =tensprod_nq_rule(struct('dim',1,'order',1));
    febf =@feblock_defor_ss_asnice;
    Style ='bd-'; Label='asNICE-Q4';

    Meshf=@block2d; ne=[1,2];
    Convertf=[];
    integration_rule =tensprod_nq_rule(struct('dim',2,'order',1));
    Edge_integration_rule =tensprod_nq_rule(struct('dim',1,'order',1));
    febf =@feblock_defor_ss_asnice;
    Style ='bd-'; Label='asNICE-Q4';
%     Meshf=@at3block2d; ne=[1,2,4,8,16,32];
%     Convertf=@T3_to_T6;
%     integration_rule =tri_rule(6);
%     Edge_integration_rule =gauss_rule(1,3);
% febf =@feblock_defor_ss;
%     Style ='kx-'; Label='T6';
% % 
%         Meshf=@block2d; ne=[1,2,4,8,16,32,64];
%     Convertf=[];
%         integration_rule = gauss_rule(2, [1 2]);
%     Edge_integration_rule =gauss_rule(1,3);
%         febf =@feblock_defor_ss_sri;
%         Style ='gs-'; Label='Q4-SRI';
% 
Mesh_options=struct('other_dimension', 1.0);
% Parameters:
E=1.0;
nu=0.4999;
% nu=0.2999;
p= 0.15;
rin=1;
rex =2;

Energy=[];
    h=[];
    
for nr=ne
    nc=3*nr;
    % Mesh'
    [fens,gcells]=Meshf(rex-rin,pi/2,nr,nc,Mesh_options);
    if (~isempty( Convertf ))
        [fens,gcells] = Convertf(fens,gcells, Mesh_options);
    end
    bdry_gcells = mesh_bdry(gcells, Mesh_options);
    icl = gcell_select(fens, bdry_gcells, struct('box', [0,0,0,pi/2],'inflate',rin/100));
    xy=get (fens,'xyz');
    for i=1:length (fens)
        r=rin+xy(i,1); a=xy(i,2);
        xy(i,:)=[r*cos(a) r*sin(a)];
    end
    fens=set(fens,'xyz', xy);
    % Material
    prop = property_linel_iso (struct('E',E,'nu',nu));
    mater = mater_defor_ss_linel_biax (struct('property',prop, ...
        'reduction','strain'));
    % Finite element block
    feb = febf (struct ('mater',mater, 'gcells',gcells,...
        'integration_rule',integration_rule));
    efeb = feblock_defor_ss (struct ('mater',mater, 'gcells',subset(bdry_gcells,icl),...
        'integration_rule',Edge_integration_rule));
    % Geometry
    geom = field(struct ('name',['geom'], 'dim', 2, 'fens',fens));
    % Define the displacement field
    u   = clone(geom,'u');
    u   = u*0; % zero out
    % Apply EBC's
    % First the horizontal plane of symmetry
    ebc_fenids=fenode_select (fens,struct('box',[0 rex 0 0],'inflate',rex/10000));
    ebc_prescribed=ones(1,length (ebc_fenids));
    ebc_comp=ebc_prescribed*0+2;
    ebc_val=ebc_fenids*0;
    u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
    % The vertical plane of symmetry
    ebc_fenids=fenode_select (fens,struct('box',[0 0 0 rex],'inflate',rex/10000));
    ebc_prescribed=ones(1,length (ebc_fenids));
    ebc_comp=ebc_prescribed*0+1;
    ebc_val=ebc_fenids*0;
    u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
    u   = apply_ebc (u);
    % Number equations
    u   = numbereqns (u);
    tic
    % Assemble the system matrix
    K = start (sparse_sysmat, get(u, 'neqns'));
    K = assemble (K, stiffness(feb, geom, u));
    % Load
    fi=force_intensity(struct('magn',@(x) (p*x'/norm(x))));
    F = start (sysvec, get(u, 'neqns'));
    F = assemble (F, distrib_loads(efeb, geom, u, fi, 2));
    % Solve
    a = get(K,'mat');
    b = get(F,'vec');
    x = a\b;
    u = scatter_sysvec(u, x);
    format long;
   En=x'*b/2
    Energy= [Energy,En];
    h= [h,1/nr];
%     % Plot
    gv=graphic_viewer;
    gv=reset (gv,struct ('limits',[0 1.06*rex 0 1.6*rex]));
    scale=5;
    cmap = jet;
    draw(feb,gv, struct ('x', geom, 'u', +scale*u, 'shrink',1.0));
    draw(feb,gv, struct ('x', geom, 'u', 0*u,'facecolor','none', 'shrink',1));
    view (2)
    figure
end

loglog(h(1:end-1),abs(diff(Energy)), Style,'lineWIDTH', 3);
font='Times';
xlabel ('log(mesh size)')
ylabel ('log(approximate energy error)')
set(gca,'Position',[0.15 0.15 0.8 0.8]);
set(gca,'FontSize',14);
set(gca,'FontName',font)
l=get(gca,'xlabel');
set (l,'FontSize',18);
set(l,'FontName',font)
l=get(gca,'ylabel');
set (l,'FontSize',18);
set(l,'FontName',font)
add_to_legend(Label);
hold on; grid on; figure (gcf); 
