function patch_test_3d_A
    % Parameters:
    E=1.0e7;
    nu=0.25;
    W=2.5;
    H=5;
    L= 2.1;
    % uc=[-2.0,-1.2,0.5, 50]'/100;
    % vc=[1.2,0.0,0, 0]'/100;
    % wc=[-0.5,0.0,0, 0]'/100;
    % uc=[ 0,  3.3, 0, 0]'/10;
    % vc=[ 3.3,0, 0, 0]'/10;
    % wc=[0, 0, 0, 0]'/10;
    uc=[ 0,  1.3, 0.3, -.7]'/10;
    vc=[ 3.3,-1, -0.567, 2.1]'/10;
    wc=[4.1, -1, 0, 0]'/10;
    shift_amplitude=1.43;

    scale = 1;
    graphics = true;

    eix=1;
    clear eltyd
    %
    % % NICE tetrahedron
%     eltyd(eix).label ='NICE-T4';
%     eltyd(eix).mf =@t4blob;
%     eltyd(eix).blf =@feblock_defor_ss_nice;
%     eltyd(eix).integration_rule= simplex_nq_rule (3);
%     eltyd(eix).surface_integration_rule=tri_rule(1);
%     eltyd(eix).styl='m^-';
%     eix=eix+1;
    %
    % % NICE tetrahedron
    eltyd(eix).label ='NICE-T4-resist';
    eltyd(eix).mf =@t4block;
    eltyd(eix).blf =@feblock_defor_ss_nice_t4;
    eltyd(eix).integration_rule= simplex_nq_rule (3);
    eltyd(eix).surface_integration_rule=tri_rule(1);
    eltyd(eix).styl='m^-';
    eix=eix+1;
    %
%     % % NICE  hexahedron
%     eltyd(eix).label ='NICE-H8';
%     eltyd(eix).mf =@block;
%     eltyd(eix).blf =@feblock_defor_ss_nice;
%     eltyd(eix).integration_rule= tensprod_nq_rule (struct('dim',3,'order',1));
%     eltyd(eix).surface_integration_rule=tensprod_nq_rule (struct('dim',2,'order',1));
%     eltyd(eix).styl='md-';
%     eix=eix+1;
    %
    % % Full integration 27-node hexahedron
    % eltyd(eix).label ='H27';
    % eltyd(eix).mf =@blockH27;
    % eltyd(eix).subdiv =1;
    % eltyd(eix).blf =@feblock_defor_ss;
    % eltyd(eix).integration_rule=gauss_rule (3,3);
    % eltyd(eix).surface_integration_rule=gauss_rule(2, 2);
    % eltyd(eix).styl='k<-';
    % eix=eix+1;
    %
    % % NICE  27-node hexahedron
    % % eltyd(eix).label ='NICE-H27';
    % % eltyd(eix).mf =@blockH27;
    % % eltyd(eix).blf =@feblock_defor_ss_nice;
    % % eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',2));
    % % eltyd(eix).surface_integration_rule=tensprod_nq_rule (struct('dim',2,'order',2));
    % % eltyd(eix).styl='ks-';
    % % eix=eix+1;
    %
    % % Reduced integration H20
    % eltyd(eix).label ='H20R';
    % eltyd(eix).mf =@blockH20;
    % eltyd(eix).blf =@feblock_defor_ss;
    % eltyd(eix).integration_rule=gauss_rule (3,2);
    % eltyd(eix).surface_integration_rule=gauss_rule(2, 2);
    % eltyd(eix).styl='ro-';
    % eix=eix+1;
    % %
    % % NICE H20
    % eltyd(eix).label ='NICE-H20';
    % eltyd(eix).mf =@blockH20;
    % eltyd(eix).blf =@feblock_defor_ss_nice;
    % eltyd(eix).integration_rule=serendipity_nq_rule (struct('dim',3,'order',1));
    % eltyd(eix).surface_integration_rule=serendipity_nq_rule (struct('dim',2,'order',1));
    % eltyd(eix).styl='ko-';
    % eix=eix+1;
    %
    % % Full integration H20
    % eltyd(eix).label ='H20';
    % eltyd(eix).mf =@blockH20;
    % eltyd(eix).blf =@feblock_defor_ss;
    % eltyd(eix).integration_rule=gauss_rule (3,3);
    % eltyd(eix).surface_integration_rule=gauss_rule(2, 2);
    % eltyd(eix).styl='b*-';
    % eix=eix+1;

    % % T10 tetrahedron
    % eltyd(eix).label ='T10';
    % eltyd(eix).mf =@t4blockT10;
    % eltyd(eix).subdiv =1;
    % eltyd(eix).blf =@feblock_defor_ss;
    % eltyd(eix).integration_rule=tet_rule (4);
    % eltyd(eix).surface_integration_rule=tri_rule(3);
    % eltyd(eix).styl='gd-';
    % eix=eix+1;
    %

    % Selective reduced integration hexahedron
    % eltyd(eix).label ='H8-SRI';
    % eltyd(eix).mf =@block;
    % eltyd(eix).blf =@feblock_defor_ss_sri;
    % eltyd(eix).integration_rule=gauss_rule (3,[1,2]);
    % eltyd(eix).surface_integration_rule=gauss_rule(2, 2);
    % eltyd(eix).styl='ks--';
    % eix=eix+1;

    % Full integration hexahedron
    % eltyd(eix).label ='H8';
    % eltyd(eix).mf =@block;
    % eltyd(eix).blf =@feblock_defor_ss;
    % eltyd(eix).integration_rule=gauss_rule (3,2);
    % eltyd(eix).surface_integration_rule=gauss_rule(2, 2);
    % eltyd(eix).styl='mx--';
    % eix=eix+1;

    mix = 1;
    clear mesd
    mesd(mix).nl= 3;
    mesd(mix).nw= 2;
    mesd(mix).nh=4;
    mix = mix+1;

    for eix = 1:length(eltyd)

        for mix = 1:length(mesd)
            ns=[];
            uzs=[];
            neqns = [];

            %% Create the mesh and initialize the geometry
            [fens,gcells]= feval (eltyd(eix).mf, L,W,H,mesd(mix).nl,mesd(mix).nw,mesd(mix).nh);
            bdry_gcells = mesh_bdry(gcells, []);
            prop = property_linel_iso (struct('E',E,'nu',nu));
            mater = mater_defor_ss_linel_triax (struct('property',prop));

            feb = feval (eltyd(eix).blf, struct ('mater',mater, 'gcells',gcells, 'integration_rule',eltyd(eix).integration_rule));
            geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
            xyz =get(geom,'values');
            xyz = (-1+2*rand(size(xyz)))*shift_amplitude +xyz;
            geom = field(struct ('name',['geom'], 'dim', 3, 'data',xyz));

            for j=1:size(xyz, 1)
                fens(j) =set(fens(j),'xyz',xyz(j,:));
             end
            
            %% Define the displacement field, and zero it out
            u   = 0*geom;

            %% Apply the Displacements at all nodes
            for j=1:size(xyz, 1)
                u1=xyz(j,:)*uc(1:3)+uc(4);
                v1=xyz(j,:)*vc(1:3)+vc(4);
                w1=xyz(j,:)*wc(1:3)+wc(4);
                u   = set_ebc(u,j*[1,1,1], [1,1,1], [1,2,3], [u1,v1,w1]);
            end
            u   = apply_ebc (u);

            %% Number the equations
            u   = numbereqns (u);
            disp ([eltyd(eix).label ': number of equations =' num2str(get(u,'neqns'))])

                Volumes = zeros(1,length(gcells));
                for i=1:length(gcells)
                    conn =get(gcells(i),'conn' );
                    X = zeros(4,3);
                    for k=1:4
                       X(k,:) =get(fens(conn(k)),'xyz');
                    end
                    Volumes(i) =t4_volume(X);
                end

                disp(['Tetrahedron Volumes: '...
                    num2str(sum(Volumes>0))  ' positive, ' ...
                    num2str(sum(Volumes==0))  ' zero, '...
                    num2str(sum(Volumes<0))  ' negative' ...
                    ]);

            for comp=1:6
                id.comp=comp;
                id.container=-Inf;
                id=inspect_integration_points(feb, geom, u, [],...
                    (1:length (gcells)), struct ('output',['Cauchy']),...
                    @mx,id);
                max_stress=id.container;
                id.container=Inf;
                id=inspect_integration_points(feb, geom, u, [], ...
                    (1:length (gcells)), struct ('output',['Cauchy']),...
                    @mn,id);
                min_stress =id.container;
                disp( ['Stress component ' num2str(comp) ': ' num2str(max_stress-min_stress)] )
            end

            %% Plot the displacement field u
            if graphics
                gv=graphic_viewer;
                gv=reset (gv,[]);
                % draw(feb,gv, struct ('x', geom,'u',0*u, 'facecolor','none'));
                fld = field_from_integration_points(feb, geom, u, [], 'Cauchy', comp);
                nvals=get(fld,'values');
                dcm=data_colormap(struct ('range',[min(nvals),max(nvals)], 'colormap',jet));
                colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, nvals)));
                draw(feb, gv, struct ('x',geom,'u', scale*u, 'colorfield',colorfield, 'shrink',0.9));
                draw(feb, gv, struct ('x',geom,'u', 0*u, 'facecolor','none','edgecolor','black', 'shrink',1));
                colormap(jet);
                cbh=colorbar;
                set(cbh,...
                    'Position',[0.8 0.15 0.03 0.7],...
                    'YLim',[0,1],...
                    'YTick',[0,1],...
                    'YTickLabel',{[num2str(min(nvals))],[num2str(max(nvals))]});%{[num2str((min(nvals)))],[num2str((max(nvals)))]}
                set(get(cbh,'XLabel'),'String','\sigma');
                title ('Stress');
                camset (gv, [6.2644    1.2063    7.9557    0.5785    0.4577    0.0621         0         0    1.0000   10.3396])
            else
                %                     plot(nels,uzs/uzex,eltyd(eix).styl,'linewidth',3); hold on
                plot(neqns,abs((uzs-uzex)/uzex),eltyd(eix).styl,'linewidth',3); hold on
                set(gca,'XScale','log')
                set(gca,'YScale','log')
                %                     set(gca,'XLim',[100,1e4])
                %                     set(gca,'YLim',[1e-3,1.0])
                grid on
                figure (gcf); pause (1)
            end
        end
    end


    function id= mn(id,out,xyz,pc)
        id.container=min(out(id.comp), id.container);
    end

    function id= mx(id,out,xyz,pc)
        id.container=max(out(id.comp), id.container);
    end


end