font='Times';
Legends = {};
Data = {};
Style = {};



Data{end+1}=[
  1./(2:11)
 0.3434    0.1470    0.0458    0.0496    0.0545    0.0599    0.0586    0.0588    0.0573    0.0567
];Style{end+1}='m^-';Legends{end+1} ='NICE-T4';

Data{end+1}=[
  1./(2:11)
    0.4553    0.3528    0.2214    0.3224    0.2777    0.3241    0.3012    0.3252    0.3126    0.3243
];Style{end+1}='md-';Legends{end+1} ='NICE-H8';


Data{end+1}=[
  1./(2:8)  
     0.1906    0.2165    0.2227    0.2239    0.2238    0.2235    0.2231
];Style{end+1}='mh-';Legends{end+1} ='NICE-H27';



for j=1:length(Data)
    data=Data{j};
    h=data(1,:); utip=data(2,:);
    loglog(h,utip,Style{j},'lineWIDTH', 3); hold on;
%     loglog(h,abs(utip-uzex)/uzex,Style{j},'lineWIDTH', 3); hold on;
end

set(gca,'XLim', [4e-2, 1]);
set(gca,'YLim', [1e-4, 1e-0]);
xlabel ('log(1/number of elements per side)')
ylabel ('log(inf-sup \lambda)')
legend(Legends,'Location','Southwest')
set(gca,'Position',[0.15 0.15 0.5 0.5]);
set(gca,'FontSize',12);
set(gca,'FontName',font)
l=get(gca,'xlabel');
set (l,'FontSize',14);
set(l,'FontName',font)
l=get(gca,'ylabel');
set (l,'FontSize',14);
set(l,'FontName',font)
hold on; grid on; figure (gcf);
saveas(gcf,[mfilename '.eps'],'eps2c');